program Pdb2Txt;
{$IFDEF FPC}
  {$MODE DELPHI}
{$ENDIF}
{$APPTYPE CONSOLE}

{%File 'Pdb2Txt.version'}

uses
  SysUtils,
  DocFile in 'Lib\PalmDoc\DocFile.pas',
  PalmDatabase in 'Lib\PalmDoc\PalmDatabase.pas',
  uConsoleApp in 'Lib\Pepak\uConsoleApp.pas',
  uStringUtils in 'Lib\Pepak\uStringUtils.pas',
  uPdb2txt in 'Lib\Pepak\uPdb2txt.pas';

procedure Convert(const FileMask: string; Recursive: boolean);
var SR: TSearchRec;
    OK: integer;
    PDB: TDocFile;
    Dir, Mask: string;
    T: TextFile;
begin
  Dir := ExtractFilePath(FileMask);
  OK := FindFirst(FileMask, faAnyFile, SR);
  if OK = 0 then
    try
      repeat
        if not Longbool(SR.Attr and (faDirectory or faVolumeID)) then
          begin
          Write(Dir + SR.Name + '     ');
          try
            PDB := TDocFile.Create(Dir + SR.Name);
            try
              AssignFile(T, Dir + SR.Name + '.txt');
              Rewrite(T);
              try
                Write(T, PDB.GetDocument);
              finally
                CloseFile(T);
                end;
            finally
              PDB.Free;
              end;
            Writeln('OK');
          except
            on E: Exception do
              Writeln(E.ClassName + ': ' + E.Message);
            end;
          end;
        OK := FindNext(SR);
      until OK <> 0;
    finally
      FindClose(SR);
      end;
  if Recursive then
    begin
    OK := FindFirst(Dir + '*.*', faDirectory, SR);
    Mask := ExtractFileName(FileMask);
    try
      while OK = 0 do
        begin
        if (SR.Name <> '.') and (SR.Name <> '..') then
          Convert(Dir + SR.Name + '\' + Mask, Recursive);
        OK := FindNext(SR);
        end;
    finally
      FindClose(SR);
      end;
    end;
end;

var ErrorMsg: string;
begin
  try
    ExitCode := 0;
    ExitCode := ExecuteConsoleApp(TPdb2Txt);
    {$IFNDEF FPC}
      if DebugHook <> 0 then
        begin
        Writeln;
        Write('Press any key to exit.');
        Readln;
        end;
    {$ENDIF}
  except
    on E: Exception do
      begin
      ErrorMsg := Format('Exception %s: %s', [E.ClassName, E.Message]);
      Writeln(ErrorMsg);
      ExitCode := 255;
      end;
    end;
end.
